#define fn_init
/**************************************************************************

FN Simple Scripts v4.1 (for multi game)

Maker --- wnsrn3436@naver.com

**************************************************************************/

globalvar fnv_send, fnv_message;
fnv_send=buffer_create()
fnv_message=buffer_create()

global._fn_noone_list_=ds_list_create()
global._fn_noone_buffer_=buffer_create()
global._fn_skip_buffer_=buffer_create()

global._fn_receive_list_=0
global._fn_message_send_id_=0
global._fn_message_id_=0

global._fn_message_break_=0
global._fn_message_skip_=0

global._fn_socket_error_str_=""
global._fn_join_check_length_=string_length(cfn_check)

#define fn_final
buffer_destroy(fnv_send)
buffer_destroy(fnv_message)
ds_list_destroy(global._fn_noone_list_)
buffer_destroy(global._fn_noone_buffer_)
buffer_destroy(global._fn_skip_buffer_)

#define fn_socket_make
var skv_socket, skv_list;
skv_socket=tcp_listen(argument0)
if socket_has_error(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); socket_destroy(skv_socket); return 0}

skv_list=ds_list_create()
ds_list_add(skv_list, skv_socket)
ds_list_add(skv_list, 0)
ds_list_add(skv_list, argument1)
ds_list_add(skv_list, buffer_create())
ds_list_add(skv_list, -1)
ds_list_add(skv_list, ds_list_create())
ds_list_add(skv_list, ds_list_create())
ds_list_add(skv_list, ds_list_create())
//socket(0), player_id(1), limit(2), saved_buffer(3), join_accept_max(4), join_soket_wait(5), join_soket(6), join_message_size(7)

return skv_list

#define fn_socket_join
var skv_socket, skv_list, skv_byte;
skv_socket=tcp_connect(argument0, argument1)
while(socket_connecting(skv_socket)){}
socket_sendbuffer_limit(skv_socket, argument2)
write_string(skv_socket, cfn_check)
socket_send(skv_socket)
while(1)
{
    if tcp_eof(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); socket_destroy(skv_socket); return 0}
    if tcp_receive(skv_socket, 4)
    {
        skv_byte=read_uint(skv_socket)
        switch(skv_byte)
        {
            case 0: global._fn_socket_error_str_=cfn_error_1; socket_destroy(skv_socket); return 0
            case 1: global._fn_socket_error_str_=cfn_error_3; socket_destroy(skv_socket); return 0
            case 2: global._fn_socket_error_str_=cfn_error_4; socket_destroy(skv_socket); return 0
            default:
                skv_list=ds_list_create()
                ds_list_add(skv_list, skv_socket)
                ds_list_add(skv_list, skv_byte)
                ds_list_add(skv_list, 0)
                ds_list_add(skv_list, buffer_create())
                //socket(0), player_id(1), server_message_size(2), saved_buffer(3)
                return skv_list
        }
    }
}

#define fn_socket_close
if !ds_list_find_value(argument0, 1)
{
    var i, skv_list, skv_size;
    
    skv_list=ds_list_find_value(argument0, 5)
    skv_size=ds_list_size(skv_list)
    for(i=0; i!=skv_size; i+=1){socket_destroy(ds_list_find_value(skv_list, i))}
    ds_list_destroy(skv_list)
    //join_soket_wait_free
    
    skv_list=ds_list_find_value(argument0, 6)
    skv_size=ds_list_size(skv_list)
    for(i=0; i!=skv_size; i+=1){socket_destroy(ds_list_find_value(skv_list, i))}
    ds_list_destroy(skv_list)
    ds_list_destroy(skv_list+1)
    //join_soket_free
}
socket_destroy(ds_list_find_value(argument0, 0))
buffer_destroy(ds_list_find_value(argument0, 3))
ds_list_destroy(argument0)

#define fn_get_error_string
return global._fn_socket_error_str_

#define fn_message_receive
global._fn_receive_list_=argument0

if !ds_list_find_value(argument0, 1)
{
    var i, j, skv_socket, skv_list, skv_server_size, skv_size, skv_var, skv_byte;
    
    skv_socket=ds_list_find_value(argument0, 0)
    skv_list=ds_list_find_value(argument0, 5)
    skv_server_size=ds_list_size(skv_list)
    for(i=0; i!=skv_server_size; i+=1)
    {
        skv_var=ds_list_find_value(skv_list, i)
        if tcp_eof(skv_var){socket_destroy(skv_var); ds_list_delete(skv_list, i); i-=1; skv_server_size-=1; continue}
        if tcp_receive_available(skv_var)
        {
            if read_string(skv_var, global._fn_join_check_length_)=cfn_check and !buffer_bytes_left(skv_var)
            {
                ds_list_add(ds_list_find_value(argument0, 6), skv_var)
                ds_list_add(ds_list_find_value(argument0, 7), 0)
                write_uint(skv_var, skv_var)
                socket_send(skv_var)
            }
            else{write_uint(skv_var, 2); socket_send(skv_var); socket_destroy(skv_var)}
            ds_list_delete(skv_list, i)
            i-=1
            skv_server_size-=1
        }
    }
    
    skv_byte=socket_accept(skv_socket)
    while(skv_byte>0)
    {
        if ds_list_find_value(argument0, 4)=-1 or ds_list_find_value(argument0, 4)>ds_list_size(skv_list)+ds_list_size(ds_list_find_value(argument0, 6))
        {
            socket_sendbuffer_limit(skv_byte, ds_list_find_value(argument0, 2))
            ds_list_add(skv_list, skv_byte)
        }
        else
        {
            if !ds_list_find_value(argument0, 5){write_uint(skv_byte, 1)}else{write_uint(skv_byte, 0)}
            socket_send(skv_byte)
            socket_destroy(skv_byte)
        }
        skv_byte=socket_accept(skv_socket)
    }
    
    skv_list=ds_list_find_value(argument0, 6)
    skv_server_size=ds_list_size(skv_list)
    for(i=0; i!=skv_server_size; i+=1)
    {
        skv_var=ds_list_find_value(skv_list, i)
        if tcp_eof(skv_var)
        {
            socket_destroy(skv_var)
            ds_list_delete(skv_list, i)
            ds_list_delete(skv_list+1, i)
            global._fn_message_send_id_=skv_var
            global._fn_socket_error_str_=cfn_error_2
            event_user(cfn_exit_player_event)
            i-=1
            skv_server_size-=1
            continue
        }
        if !ds_list_find_value(skv_list+1, i){if tcp_receive(skv_var, 4){ds_list_replace(skv_list+1, i, read_uint(skv_var))}}
        if ds_list_find_value(skv_list+1, i)
        {
            if tcp_receive(skv_var, ds_list_find_value(skv_list+1, i))
            {
                skv_byte=read_uint(skv_var)
                if skv_byte<2
                {
                    if !skv_byte
                    {
                        write_uint(ds_list_find_value(argument0, 3), socket_receivebuffer_size(skv_var)-10)
                        write_buffer_part(ds_list_find_value(argument0, 3), skv_var, socket_receivebuffer_size(skv_var))
                    }
                    for(j=0; j<i; j+=1)
                    {
                        buffer_set_readpos(skv_var, 4)
                        write_uint(ds_list_find_value(skv_list, j), socket_receivebuffer_size(skv_var)-4)
                        write_buffer_part(ds_list_find_value(skv_list, j), skv_var, socket_receivebuffer_size(skv_var))
                        socket_send(ds_list_find_value(skv_list, j))
                    }
                    skv_size=ds_list_size(skv_list)
                    for(j=i+1; j<skv_size; j+=1)
                    {
                        buffer_set_readpos(skv_var, 4)
                        write_uint(ds_list_find_value(skv_list, j), socket_receivebuffer_size(skv_var)-4)
                        write_buffer_part(ds_list_find_value(skv_list, j), skv_var, socket_receivebuffer_size(skv_var))
                        socket_send(ds_list_find_value(skv_list, j))
                    }
                }
                else
                {
                    if skv_byte!=2
                    {
                        skv_byte-=2
                        write_uint(skv_byte, socket_receivebuffer_size(skv_var)-4)
                        write_buffer_part(skv_byte, skv_var, socket_receivebuffer_size(skv_var))
                        socket_send(skv_byte)
                    }
                    else
                    {
                        write_uint(ds_list_find_value(argument0, 3), socket_receivebuffer_size(skv_var)-10)
                        write_buffer_part(ds_list_find_value(argument0, 3), skv_var, socket_receivebuffer_size(skv_var))
                    }
                }
                ds_list_replace(skv_list+1, i, 0)
                i-=1
                continue
            }
        }
    }
}
else
{
    var skv_socket, skv_byte;
    skv_socket=ds_list_find_value(argument0, 0)
    if tcp_eof(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); event_user(cfn_server_error_event); return 0}
    while(1)
    {
        if !ds_list_find_value(argument0, 2){if tcp_receive(skv_socket, 4){ds_list_replace(argument0, 2, read_uint(skv_socket))}}
        if ds_list_find_value(argument0, 2)
        {
            if tcp_receive(skv_socket, ds_list_find_value(argument0, 2))
            {
                write_uint(ds_list_find_value(argument0, 3), ds_list_find_value(argument0, 2)-6)
                write_buffer(ds_list_find_value(argument0, 3), skv_socket)
                ds_list_replace(argument0, 2, 0)
                continue
            }
        }
        break
    }
}

skv_socket=ds_list_find_value(argument0, 3)
while(buffer_bytes_left(skv_socket))
{
    if !global._fn_message_break_
    {
        buffer_clear(fnv_message)
        skv_byte=read_uint(skv_socket)
        global._fn_message_send_id_=read_uint(skv_socket)
        global._fn_message_id_=read_ushort(skv_socket)
        write_buffer_part(fnv_message, skv_socket, skv_byte)
        event_user(cfn_message_event)
    }
    else{break}
}
if !global._fn_message_break_{buffer_clear(skv_socket)}
else{global._fn_message_break_=0}

if global._fn_message_skip_
{
    write_buffer(skv_socket, global._fn_skip_buffer_)
    global._fn_message_skip_=0
}

#define fn_message_break
global._fn_message_break_=1

#define fn_message_skip
if global._fn_message_skip_=0
{
    buffer_clear(global._fn_skip_buffer_)
    global._fn_message_skip_=1
}
write_uint(global._fn_skip_buffer_, buffer_size(fnv_message))
write_uint(global._fn_skip_buffer_, global._fn_message_send_id_)
write_ushort(global._fn_skip_buffer_, global._fn_message_id_)
write_buffer(global._fn_skip_buffer_, fnv_message)

#define fn_get_receive_handle
return global._fn_receive_list_

#define fn_get_message_id
return global._fn_message_id_

#define fn_get_message_send_id
return global._fn_message_send_id_

#define fn_message_send
if ds_list_find_value(argument0, 1)
{
    var skv_socket;
    if argument1<-2
    {
        skv_socket=ds_list_find_value(argument0, 0)
        write_uint(skv_socket, 10+buffer_size(fnv_send))
        write_uint(skv_socket, 0)
        write_uint(skv_socket, ds_list_find_value(argument0, 1))
        write_ushort(skv_socket, argument2)
        write_buffer(skv_socket, fnv_send)
        socket_send(skv_socket)
        if argument1=-4
        {
            skv_socket=ds_list_find_value(argument0, 3)
            write_uint(skv_socket, buffer_size(fnv_send))
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument2)
            write_buffer(skv_socket, fnv_send)
        }
    }
    else if argument1<0
    {
        skv_socket=ds_list_find_value(argument0, 0)
        write_uint(skv_socket, 10+buffer_size(fnv_send))
        write_uint(skv_socket, 1)
        write_uint(skv_socket, ds_list_find_value(argument0, 1))
        write_ushort(skv_socket, argument2)
        write_buffer(skv_socket, fnv_send)
        socket_send(skv_socket)
        if argument1=-2
        {
            skv_socket=ds_list_find_value(argument0, 3)
            write_uint(skv_socket, buffer_size(fnv_send))
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument2)
            write_buffer(skv_socket, fnv_send)
        }
    }
    else
    {
        if ds_list_find_value(argument0, 1)!=argument1
        {
            skv_socket=ds_list_find_value(argument0, 0)
            write_uint(skv_socket, 10+buffer_size(fnv_send))
            write_uint(skv_socket, argument1+2)
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument2)
            write_buffer(skv_socket, fnv_send)
            socket_send(skv_socket)
        }
        else
        {
            skv_socket=ds_list_find_value(argument0, 3)
            write_uint(skv_socket, buffer_size(fnv_send))
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument2)
            write_buffer(skv_socket, fnv_send)
        }
    }
}
else
{
    buffer_clear(global._fn_noone_buffer_)
    write_uint(global._fn_noone_buffer_, 0)
    write_ushort(global._fn_noone_buffer_, argument2)
    write_buffer(global._fn_noone_buffer_, fnv_send)
    if argument1<0
    {
        var i, skv_list, skv_byte, skv_socket;
        skv_list=ds_list_find_value(argument0, 6)
        skv_byte=ds_list_size(skv_list)
        for(i=0; i!=skv_byte; i+=1)
        {
            skv_soket=ds_list_find_value(skv_list, i)
            write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
            write_buffer(skv_soket, global._fn_noone_buffer_)
            socket_send(skv_soket)
        }
        if argument1<-1 and argument1!=-5
        {
            write_uint(ds_list_find_value(argument0, 3), buffer_size(fnv_send))
            write_buffer(ds_list_find_value(argument0, 3), global._fn_noone_buffer_)
        }
    }
    else
    {
        if argument1!=0
        {
            write_uint(argument1, buffer_size(global._fn_noone_buffer_))
            write_buffer(argument1, global._fn_noone_buffer_)
            socket_send(argument1)
        }
        else
        {
            write_uint(ds_list_find_value(argument0, 3), buffer_size(fnv_send))
            write_buffer(ds_list_find_value(argument0, 3), global._fn_noone_buffer_)
        }
    }
}

#define fn_get_my_player_id
return ds_list_find_value(argument0, 1)

#define fn_get_player_number
if !ds_list_find_value(argument0, 1){return ds_list_size(ds_list_find_value(argument0, 6))}
return 0

#define fn_get_player_ds_list
if !ds_list_find_value(argument0, 1){return ds_list_find_value(argument0, 6)}
return 0

#define fn_get_player_ip_address
if !ds_list_find_value(argument0, 1) and argument1{return socket_remote_ip(argument1)}
return ""

#define fn_set_player_accept_max
if !ds_list_find_value(argument0, 1){ds_list_replace(argument0, 4, argument1)}

#define write_string_v2
write_ushort(argument0, string_length(argument1))
write_string(argument0, argument1)

#define read_string_v2
return read_string(argument0, read_ushort(argument0))

