#define fn_init
/**************************************************************************

FN Simple Scripts v4.1 (for online game)

Maker --- wnsrn3436@naver.com

**************************************************************************/

globalvar fnv_send, fnv_message;
fnv_send=buffer_create()
fnv_message=buffer_create()

global._fn_noone_list_=ds_list_create()
global._fn_noone_buffer_=buffer_create()
global._fn_skip_buffer_=buffer_create()

global._fn_receive_list_=0
global._fn_message_read_space_=0
global._fn_message_send_space_=0
global._fn_message_send_id_=0
global._fn_message_id_=0

global._fn_message_break_=0
global._fn_message_skip_=0

global._fn_socket_error_str_=""
global._fn_join_check_length_=string_length(cfn_check)

#define fn_final
buffer_destroy(fnv_send)
buffer_destroy(fnv_message)
ds_list_destroy(global._fn_noone_list_)
buffer_destroy(global._fn_noone_buffer_)
buffer_destroy(global._fn_skip_buffer_)

#define fn_socket_make
var skv_socket, skv_list;
skv_socket=tcp_listen(argument0)
if socket_has_error(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); socket_destroy(skv_socket); return 0}

skv_list=ds_list_create()
ds_list_add(skv_list, skv_socket)
ds_list_add(skv_list, 0)
ds_list_add(skv_list, argument1)
ds_list_add(skv_list, buffer_create())
ds_list_add(skv_list, argument3)
ds_list_add(skv_list, -1)
ds_list_add(skv_list, ds_list_create())
ds_list_add(skv_list, 0)
repeat(argument2)
{
    ds_list_add(skv_list, ds_list_create())
    ds_list_add(skv_list, ds_list_create())
}
//socket(0), player_id(1), limit(2), saved_buffer(3), space(4), join_accept_max(5), join_socket_wait(6), join_number(7), { join_socket(8), join_message_size(9) ... }

return skv_list

#define fn_socket_join
var skv_socket, skv_list, skv_byte;
skv_socket=tcp_connect(argument0, argument1)
while(socket_connecting(skv_socket)){}
socket_sendbuffer_limit(skv_socket, argument2)
write_string(skv_socket, cfn_check)
write_ushort(skv_socket, argument3)
socket_send(skv_socket)
while(1)
{
    if tcp_eof(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); socket_destroy(skv_socket); return 0}
    if tcp_receive(skv_socket, 4)
    {
        skv_byte=read_uint(skv_socket)
        switch(skv_byte)
        {
            case 0: global._fn_socket_error_str_=cfn_error_1; socket_destroy(skv_socket); return 0
            case 1: global._fn_socket_error_str_=cfn_error_3; socket_destroy(skv_socket); return 0
            case 2: global._fn_socket_error_str_=cfn_error_4; socket_destroy(skv_socket); return 0
            default:
                skv_list=ds_list_create()
                ds_list_add(skv_list, skv_socket)
                ds_list_add(skv_list, skv_byte)
                ds_list_add(skv_list, 0)
                ds_list_add(skv_list, buffer_create())
                ds_list_add(skv_list, argument3)
                //socket(0), player_id(1), server_message_size(2), saved_buffer(3), space(4)
                return skv_list
        }
    }
}

#define fn_socket_close
if !ds_list_find_value(argument0, 1)
{
    var i, j, skv_list, skv_size, skv_size2;
    
    skv_list=ds_list_find_value(argument0, 6)
    skv_size=ds_list_size(skv_list)
    for(i=0; i!=skv_size; i+=1){socket_destroy(ds_list_find_value(skv_list, i))}
    ds_list_destroy(skv_list)
    //join_socket_wait_free
    
    skv_size=ds_list_size(argument0)
    for(i=8; i<skv_size; i+=2)
    {
        skv_list=ds_list_find_value(argument0, i)
        skv_size2=ds_list_size(skv_list)
        for(j=0; j!=skv_size2; j+=1){socket_destroy(ds_list_find_value(skv_list, j))}
        ds_list_destroy(skv_list)
        ds_list_destroy(skv_list+1)
    }
    //join_socket_free
}
socket_destroy(ds_list_find_value(argument0, 0))
buffer_destroy(ds_list_find_value(argument0, 3))
ds_list_destroy(argument0)

#define fn_get_error_string
return global._fn_socket_error_str_

#define fn_message_receive
global._fn_receive_list_=argument0

if !ds_list_find_value(argument0, 1)
{
    var i, j, k, l, skv_socket, skv_list, skv_server_size, skv_server_size2, skv_size, skv_var, skv_byte, skv_pos;
    
    skv_socket=ds_list_find_value(argument0, 0)
    skv_list=ds_list_find_value(argument0, 6)
    skv_server_size=ds_list_size(skv_list)
    for(i=0; i!=skv_server_size; i+=1)
    {
        skv_var=ds_list_find_value(skv_list, i)
        if tcp_eof(skv_var){socket_destroy(skv_var); ds_list_delete(skv_list, i); i-=1; skv_server_size-=1; continue}
        if tcp_receive_available(skv_var)
        {
            if read_string(skv_var, global._fn_join_check_length_)=cfn_check and buffer_bytes_left(skv_var)=2
            {
                skv_byte=ds_list_find_value(argument0, read_ushort(skv_var)*2+8)
                ds_list_add(skv_byte, skv_var)
                ds_list_add(skv_byte+1, 0)
                write_uint(skv_var, skv_var)
                socket_send(skv_var)
                ds_list_replace(argument0, 7, ds_list_find_value(argument0, 7)+1)
            }
            else{write_uint(skv_var, 2); socket_send(skv_var); socket_destroy(skv_var)}
            ds_list_delete(skv_list, i)
            i-=1
            skv_server_size-=1
        }
    }
    
    skv_byte=socket_accept(skv_socket)
    while(skv_byte>0)
    {
        if ds_list_find_value(argument0, 5)=-1 or ds_list_find_value(argument0, 5)>ds_list_size(skv_list)+ds_list_find_value(argument0, 7)
        {
            socket_sendbuffer_limit(skv_byte, ds_list_find_value(argument0, 2))
            ds_list_add(skv_list, skv_byte)
        }
        else
        {
            if !ds_list_find_value(argument0, 5){write_uint(skv_byte, 1)}else{write_uint(skv_byte, 0)}
            socket_send(skv_byte)
            socket_destroy(skv_byte)
        }
        skv_byte=socket_accept(skv_socket)
    }
    
    skv_server_size=ds_list_size(argument0)
    for(i=8; i<skv_server_size; i+=2)
    {
        skv_list=ds_list_find_value(argument0, i)
        skv_server_size2=ds_list_size(skv_list)
        for(j=0; j!=skv_server_size2; j+=1)
        {
            skv_var=ds_list_find_value(skv_list, j)
            if tcp_eof(skv_var)
            {
                socket_destroy(skv_var)
                ds_list_delete(skv_list, j)
                ds_list_delete(skv_list+1, j)
                ds_list_replace(argument0, 7, ds_list_find_value(argument0, 7)-1)
                global._fn_message_send_space_=(i-8)/2
                global._fn_message_send_id_=skv_var
                global._fn_socket_error_str_=cfn_error_2
                event_user(cfn_exit_player_event)
                j-=1
                skv_server_size2-=1
                continue
            }
            if !ds_list_find_value(skv_list+1, j)
            {
                if tcp_receive(skv_var, 4)
                {
                    skv_byte=read_uint(skv_var)
                    if skv_byte{ds_list_replace(skv_list+1, j, skv_byte)}
                    else
                    {
                        while(1){if tcp_receive(skv_var, 2){break}}
                        global._fn_message_send_space_=(i-8)/2
                        global._fn_message_send_id_=skv_var
                        global._fn_message_id_=read_ushort(skv_var)
                        skv_pos=ds_list_find_value(argument0, global._fn_message_id_*2+8)
                        ds_list_add(skv_pos, skv_var)
                        ds_list_add(skv_pos+1, 0)
                        ds_list_delete(skv_list, j)
                        ds_list_delete(skv_list+1, j)
                        write_uint(skv_var, 0)
                        socket_send(skv_var)
                        event_user(cfn_player_space_change)
                        j-=1
                        skv_server_size2-=1
                        continue
                    }
                }
            }
            if ds_list_find_value(skv_list+1, j)
            {
                if tcp_receive(skv_var, ds_list_find_value(skv_list+1, j))
                {
                    skv_byte=read_uint(skv_var)
                    skv_pos=read_ushort(skv_var)
                    if skv_byte<2
                    {
                        if !skv_byte
                        {
                            buffer_set_readpos(skv_var, 4)
                            write_uint(ds_list_find_value(argument0, 3), socket_receivebuffer_size(skv_var)-14)
                            write_buffer_part(ds_list_find_value(argument0, 3), skv_var, socket_receivebuffer_size(skv_var))
                        }
                        switch(skv_pos)
                        {
                            case 2:
                                for(k=0; k<j; k+=1)
                                {
                                    buffer_set_readpos(skv_var, 4)
                                    write_uint(ds_list_find_value(skv_list, k), socket_receivebuffer_size(skv_var)-4)
                                    write_buffer_part(ds_list_find_value(skv_list, k), skv_var, socket_receivebuffer_size(skv_var))
                                    socket_send(ds_list_find_value(skv_list, k))
                                }
                                for(k=j+1; k<skv_server_size2; k+=1)
                                {
                                    buffer_set_readpos(skv_var, 4)
                                    write_uint(ds_list_find_value(skv_list, k), socket_receivebuffer_size(skv_var)-4)
                                    write_buffer_part(ds_list_find_value(skv_list, k), skv_var, socket_receivebuffer_size(skv_var))
                                    socket_send(ds_list_find_value(skv_list, k))
                                }
                                break
                            case 1:
                                for(k=8; k<i; k+=2)
                                {
                                    skv_byte=ds_list_find_value(argument0, k)
                                    skv_size=ds_list_size(skv_byte)
                                    for(l=0; l!=skv_size; l+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, l), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, l), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, l))
                                    }
                                }
                                for(k=i+2; k<skv_server_size; k+=2)
                                {
                                    skv_byte=ds_list_find_value(argument0, k)
                                    skv_size=ds_list_size(skv_byte)
                                    for(l=0; l!=skv_size; l+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, l), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, l), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, l))
                                    }
                                }
                                for(k=0; k<j; k+=1)
                                {
                                    buffer_set_readpos(skv_var, 4)
                                    write_uint(ds_list_find_value(skv_list, k), socket_receivebuffer_size(skv_var)-4)
                                    write_buffer_part(ds_list_find_value(skv_list, k), skv_var, socket_receivebuffer_size(skv_var))
                                    socket_send(ds_list_find_value(skv_list, k))
                                }
                                for(k=j+1; k<skv_server_size2; k+=1)
                                {
                                    buffer_set_readpos(skv_var, 4)
                                    write_uint(ds_list_find_value(skv_list, k), socket_receivebuffer_size(skv_var)-4)
                                    write_buffer_part(ds_list_find_value(skv_list, k), skv_var, socket_receivebuffer_size(skv_var))
                                    socket_send(ds_list_find_value(skv_list, k))
                                }
                                break
                            case 0:
                                for(k=8; k<i; k+=2)
                                {
                                    skv_byte=ds_list_find_value(argument0, k)
                                    skv_size=ds_list_size(skv_byte)
                                    for(l=0; l!=skv_size; l+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, l), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, l), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, l))
                                    }
                                }
                                for(k=i+2; k<skv_server_size; k+=2)
                                {
                                    skv_byte=ds_list_find_value(argument0, k)
                                    skv_size=ds_list_size(skv_byte)
                                    for(l=0; l!=skv_size; l+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, l), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, l), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, l))
                                    }
                                }
                                break
                            default:
                                skv_byte=ds_list_find_value(argument0, (skv_pos-3)*2+8)
                                if skv_byte!=skv_list
                                {
                                    skv_size=ds_list_size(skv_byte)
                                    for(k=0; k<skv_size; k+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, k), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, k), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, k))
                                    }
                                }
                                else
                                {
                                    for(k=0; k<j; k+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, k), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, k), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, k))
                                    }
                                    for(k=j+1; k<skv_server_size2; k+=1)
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(ds_list_find_value(skv_byte, k), socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(ds_list_find_value(skv_byte, k), skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(ds_list_find_value(skv_byte, k))
                                    }
                                }
                        }
                    }
                    else
                    {
                        if skv_byte!=2
                        {
                            skv_byte-=2
                            switch(skv_pos)
                            {
                                case 2:
                                    if ds_list_find_index(skv_list, skv_byte)!=-1
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(skv_byte, socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(skv_byte, skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(skv_byte)
                                    }
                                    break
                                case 1:
                                    buffer_set_readpos(skv_var, 4)
                                    write_uint(skv_byte, socket_receivebuffer_size(skv_var)-4)
                                    write_buffer_part(skv_byte, skv_var, socket_receivebuffer_size(skv_var))
                                    socket_send(skv_byte)
                                    break
                                case 0:
                                    if ds_list_find_index(skv_list, skv_byte)=-1
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(skv_byte, socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(skv_byte, skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(skv_byte)
                                    }
                                    break
                                default:
                                    if ds_list_find_index(ds_list_find_value(argument0, (skv_pos-3)*2+8), skv_byte)!=-1
                                    {
                                        buffer_set_readpos(skv_var, 4)
                                        write_uint(skv_byte, socket_receivebuffer_size(skv_var)-4)
                                        write_buffer_part(skv_byte, skv_var, socket_receivebuffer_size(skv_var))
                                        socket_send(skv_byte)
                                    }
                            }
                        }
                        else
                        {
                            buffer_set_readpos(skv_var, 4)
                            write_uint(ds_list_find_value(argument0, 3), socket_receivebuffer_size(skv_var)-14)
                            write_buffer_part(ds_list_find_value(argument0, 3), skv_var, socket_receivebuffer_size(skv_var))
                        }
                    }
                    ds_list_replace(skv_list+1, j, 0)
                    j-=1
                    continue
                }
            }
        }
    }
}
else
{
    var skv_socket, skv_pos, skv_byte;
    skv_socket=ds_list_find_value(argument0, 0)
    if tcp_eof(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); event_user(cfn_server_error_event); return 0}
    while(1)
    {
        if !ds_list_find_value(argument0, 2){if tcp_receive(skv_socket, 4){ds_list_replace(argument0, 2, read_uint(skv_socket))}}
        if ds_list_find_value(argument0, 2)
        {
            if tcp_receive(skv_socket, ds_list_find_value(argument0, 2))
            {
                write_uint(ds_list_find_value(argument0, 3), ds_list_find_value(argument0, 2)-10)
                write_buffer(ds_list_find_value(argument0, 3), skv_socket)
                ds_list_replace(argument0, 2, 0)
                continue
            }
        }
        break
    }
}

skv_socket=ds_list_find_value(argument0, 3)
skv_byte=ds_list_find_value(argument0, 4)
while(buffer_bytes_left(skv_socket))
{
    if !global._fn_message_break_
    {
        buffer_clear(fnv_message)
        skv_pos=read_uint(skv_socket)
        global._fn_message_read_space_=read_ushort(skv_socket)-3
        global._fn_message_send_space_=read_ushort(skv_socket)
        if (global._fn_message_read_space_<0 and (global._fn_message_read_space_=-2 or (global._fn_message_read_space_=-1 and global._fn_message_send_space_=skv_byte) or (global._fn_message_read_space_=-3 and global._fn_message_send_space_!=skv_byte))) or skv_byte=global._fn_message_read_space_
        {
            global._fn_message_send_id_=read_uint(skv_socket)
            global._fn_message_id_=read_ushort(skv_socket)
            write_buffer_part(fnv_message, skv_socket, skv_pos)
            event_user(cfn_message_event)
        }
        else{buffer_set_readpos(skv_socket, buffer_size(skv_socket)-buffer_bytes_left(skv_socket)+skv_pos+6)}
    }
    else{break}
}
if !global._fn_message_break_{buffer_clear(skv_socket)}
else{global._fn_message_break_=0}

if global._fn_message_skip_
{
    write_buffer(skv_socket, global._fn_skip_buffer_)
    global._fn_message_skip_=0
}

#define fn_message_break
global._fn_message_break_=1

#define fn_message_skip
if global._fn_message_skip_=0
{
    buffer_clear(global._fn_skip_buffer_)
    global._fn_message_skip_=1
}
write_uint(global._fn_skip_buffer_, buffer_size(fnv_message))
write_ushort(global._fn_skip_buffer_, global._fn_message_read_space_)
write_ushort(global._fn_skip_buffer_, global._fn_message_send_space_)
write_uint(global._fn_skip_buffer_, global._fn_message_send_id_)
write_ushort(global._fn_skip_buffer_, global._fn_message_id_)
write_buffer(global._fn_skip_buffer_, fnv_message)

#define fn_get_receive_handle
return global._fn_receive_list_

#define fn_get_message_send_space
return global._fn_message_send_space_

#define fn_get_message_send_id
return global._fn_message_send_id_

#define fn_get_message_id
return global._fn_message_id_

#define fn_message_send
if ds_list_find_value(argument0, 1)
{
    if argument2<-2
    {
        var skv_socket, skv_space;
        skv_space=ds_list_find_value(argument0, 4)
        skv_socket=ds_list_find_value(argument0, 0)
        write_uint(skv_socket, 14+buffer_size(fnv_send))
        write_uint(skv_socket, 0)
        write_ushort(skv_socket, argument1+3)
        write_ushort(skv_socket, skv_space)
        write_uint(skv_socket, ds_list_find_value(argument0, 1))
        write_ushort(skv_socket, argument3)
        write_buffer(skv_socket, fnv_send)
        socket_send(skv_socket)
        if argument2=-4
        {
            if (argument1<0 and argument1!=-3) or skv_space=argument1
            {
                skv_socket=ds_list_find_value(argument0, 3)
                write_uint(skv_socket, buffer_size(fnv_send))
                write_ushort(skv_socket, argument1+3)
                write_ushort(skv_socket, skv_space)
                write_uint(skv_socket, ds_list_find_value(argument0, 1))
                write_ushort(skv_socket, argument3)
                write_buffer(skv_socket, fnv_send)
            }
        }
    }
    else if argument2<0
    {
        var skv_socket, skv_space;
        skv_space=ds_list_find_value(argument0, 4)
        skv_socket=ds_list_find_value(argument0, 0)
        write_uint(skv_socket, 14+buffer_size(fnv_send))
        write_uint(skv_socket, 1)
        write_ushort(skv_socket, argument1+3)
        write_ushort(skv_socket, skv_space)
        write_uint(skv_socket, ds_list_find_value(argument0, 1))
        write_ushort(skv_socket, argument3)
        write_buffer(skv_socket, fnv_send)
        socket_send(skv_socket)
        if argument2=-2
        {
            if (argument1<0 and argument1!=-3) or skv_space=argument1
            {
                skv_socket=ds_list_find_value(argument0, 3)
                write_uint(skv_socket, buffer_size(fnv_send))
                write_ushort(skv_socket, argument1+3)
                write_ushort(skv_socket, skv_space)
                write_uint(skv_socket, ds_list_find_value(argument0, 1))
                write_ushort(skv_socket, argument3)
                write_buffer(skv_socket, fnv_send)
            }
        }
    }
    else
    {
        var skv_socket;
        if ds_list_find_value(argument0, 1)!=argument2
        {
            skv_socket=ds_list_find_value(argument0, 0)
            write_uint(skv_socket, 14+buffer_size(fnv_send))
            write_uint(skv_socket, argument2+2)
            write_ushort(skv_socket, argument1+3)
            write_ushort(skv_socket, ds_list_find_value(argument0, 4))
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument3)
            write_buffer(skv_socket, fnv_send)
            socket_send(skv_socket)
        }
        else
        {
            skv_socket=ds_list_find_value(argument0, 3)
            write_uint(skv_socket, buffer_size(fnv_send))
            write_ushort(skv_socket, argument1+3)
            write_ushort(skv_socket, ds_list_find_value(argument0, 4))
            write_uint(skv_socket, ds_list_find_value(argument0, 1))
            write_ushort(skv_socket, argument3)
            write_buffer(skv_socket, fnv_send)
        }
    }
}
else
{
    buffer_clear(global._fn_noone_buffer_)
    write_ushort(global._fn_noone_buffer_, argument1+3)
    write_ushort(global._fn_noone_buffer_, ds_list_find_value(argument0, 4))
    write_uint(global._fn_noone_buffer_, 0)
    write_ushort(global._fn_noone_buffer_, argument3)
    write_buffer(global._fn_noone_buffer_, fnv_send)
    if argument2<0
    {
        switch(argument1)
        {
            case -1:
                var i, skv_list, skv_byte, skv_soket;
                skv_list=ds_list_find_value(argument0, ds_list_find_value(argument0, 4)*2+8)
                skv_byte=ds_list_size(skv_list)
                for(i=0; i!=skv_byte; i+=1)
                {
                    skv_soket=ds_list_find_value(skv_list, i)
                    write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
                    write_buffer(skv_soket, global._fn_noone_buffer_)
                    socket_send(skv_soket)
                }
                break
            case -2:
                var i, j, skv_list, skv_byte, skv_byte2, skv_soket;
                skv_byte=ds_list_size(argument0)
                for(i=8; i<skv_byte; i+=2)
                {
                    skv_list=ds_list_find_value(argument0, i)
                    skv_byte2=ds_list_size(skv_list)
                    for(j=0; j!=skv_byte2; j+=1)
                    {
                        skv_soket=ds_list_find_value(skv_list, j)
                        write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
                        write_buffer(skv_soket, global._fn_noone_buffer_)
                        socket_send(skv_soket)
                    }
                }
                break
            case -3:
                var i, j, skv_list, skv_byte, skv_byte2, skv_soket;
                skv_byte=ds_list_find_value(argument0, 4)
                for(i=8; i<skv_byte; i+=2)
                {
                    skv_list=ds_list_find_value(argument0, i)
                    skv_byte2=ds_list_size(skv_list)
                    for(j=0; j!=skv_byte2; j+=1)
                    {
                        skv_soket=ds_list_find_value(skv_list, j)
                        write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
                        write_buffer(skv_soket, global._fn_noone_buffer_)
                        socket_send(skv_soket)
                    }
                }
                skv_byte2=ds_list_size(argument0)
                for(i=skv_byte+2; i<skv_byte2; i+=2)
                {
                    skv_list=ds_list_find_value(argument0, i)
                    skv_byte=ds_list_size(skv_list)
                    for(j=0; j!=skv_byte; j+=1)
                    {
                        skv_soket=ds_list_find_value(skv_list, j)
                        write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
                        write_buffer(skv_soket, global._fn_noone_buffer_)
                        socket_send(skv_soket)
                    }
                }
                break
            default:
                var i, skv_list, skv_byte, skv_soket;
                skv_list=ds_list_find_value(argument0, argument1*2+8)
                skv_byte=ds_list_size(skv_list)
                for(i=0; i!=skv_byte; i+=1)
                {
                    skv_soket=ds_list_find_value(skv_list, i)
                    write_uint(skv_soket, buffer_size(global._fn_noone_buffer_))
                    write_buffer(skv_soket, global._fn_noone_buffer_)
                    socket_send(skv_soket)
                }
        }
        if argument2<-1 and argument2!=-5
        {
            if (argument1<0 and argument1!=-3) or ds_list_find_value(argument0, 4)=argument1
            {
                write_uint(ds_list_find_value(argument0, 3), buffer_size(fnv_send))
                write_buffer(ds_list_find_value(argument0, 3), global._fn_noone_buffer_)
            }
        }
    }
    else
    {
        if argument2!=0
        {
            switch(argument1)
            {
                case -1:
                    if ds_list_find_index(ds_list_find_value(argument0, ds_list_find_value(argument0, 4)*2+8), argument2)!=-1
                    {
                        write_uint(argument2, buffer_size(global._fn_noone_buffer_))
                        write_buffer(argument2, global._fn_noone_buffer_)
                        socket_send(argument2)
                    }
                    break
                case -2:
                    write_uint(argument2, buffer_size(global._fn_noone_buffer_))
                    write_buffer(argument2, global._fn_noone_buffer_)
                    socket_send(argument2)
                    break
                case -3:
                    if ds_list_find_index(ds_list_find_value(argument0, ds_list_find_value(argument0, 4)*2+8), argument2)=-1
                    {
                        write_uint(argument2, buffer_size(global._fn_noone_buffer_))
                        write_buffer(argument2, global._fn_noone_buffer_)
                        socket_send(argument2)
                    }
                    break
                default:
                    if ds_list_find_index(ds_list_find_value(argument0, argument1*2+8), argument2)!=-1
                    {
                        write_uint(argument2, buffer_size(global._fn_noone_buffer_))
                        write_buffer(argument2, global._fn_noone_buffer_)
                        socket_send(argument2)
                    }
            }
        }
        else
        {
            if (argument1<0 and argument1!=-3) or ds_list_find_value(argument0, 4)=argument1
            {
                write_uint(ds_list_find_value(argument0, 3), buffer_size(fnv_send))
                write_buffer(ds_list_find_value(argument0, 3), global._fn_noone_buffer_)
            }
        }
    }
}

#define fn_get_my_space
return ds_list_find_value(argument0, 4)

#define fn_get_my_player_id
return ds_list_find_value(argument0, 1)

#define fn_get_player_number
if !ds_list_find_value(argument0, 1){return ds_list_find_value(argument0, 7)}
return 0

#define fn_get_space_player_number
if !ds_list_find_value(argument0, 1){return ds_list_size(ds_list_find_value(argument0, argument1*2+8))}
return 0

#define fn_get_space_player_ds_list
if !ds_list_find_value(argument0, 1){return ds_list_find_value(argument0, argument1*2+8)}
return 0

#define fn_get_player_ip_address
if !ds_list_find_value(argument0, 1) and argument1{return socket_remote_ip(argument1)}
return ""

#define fn_set_my_space
if ds_list_find_value(argument0, 1)
{
    var skv_socket, skv_pos, skv_byte;
    skv_socket=ds_list_find_value(argument0, 0)
    write_uint(skv_socket, 0)
    write_ushort(skv_socket, argument1)
    socket_send(skv_socket)
    while(1)
    {
        if tcp_eof(skv_socket){global._fn_socket_error_str_=socket_error(skv_socket); event_user(cfn_server_error_event); return 0}
        if !ds_list_find_value(argument0, 2)
        {
            if tcp_receive(skv_socket, 4)
            {
                skv_byte=read_uint(skv_socket)
                if skv_byte{ds_list_replace(argument0, 2, skv_byte)}else{ds_list_replace(argument0, 4, argument1); break}
            }
        }
        if ds_list_find_value(argument0, 2)
        {
            if tcp_receive(skv_socket, ds_list_find_value(argument0, 2))
            {
                write_uint(ds_list_find_value(argument0, 3), ds_list_find_value(argument0, 2)-10)
                write_buffer(ds_list_find_value(argument0, 3), skv_socket)
                ds_list_replace(argument0, 2, 0)
            }
        }
    }
}
else
{
    global._fn_message_send_space_=ds_list_find_value(argument0, 4)
    global._fn_message_send_id_=0
    global._fn_message_id_=argument1
    ds_list_replace(argument0, 4, argument1)
    event_user(cfn_player_space_change)
}

#define fn_set_player_accept_max
if !ds_list_find_value(argument0, 1){ds_list_replace(argument0, 5, argument1)}

#define write_string_v2
write_ushort(argument0, string_length(argument1))
write_string(argument0, argument1)

#define read_string_v2
return read_string(argument0, read_ushort(argument0))

